<?php
// PHP/MySQL database object
class dbObject
{
	var $db;			// database pointer
	var $dbHost;		// database host
	var $dbUser;		// database user
	var $dbPass;		// database password
	var $dbName;		// database name

	var $pagesize;		// page size
	var $result;		// returned data
	var $rowcount;		// number of rows affected/returned
	var $pagecount;		// number of pages returned
	var $rowfrom;		// returning rows from index
	var $rowto;			// returning rows to index

	// object constructor
	function dbObject() {

		// define default database connection
		$this->db=NULL;

		if (defined('MYSQLHOST')) $this->dbHost=MYSQLHOST; else $this->dbHost='localhost';
		if (defined('MYSQLDBNAME')) $this->dbName=MYSQLDBNAME; else $this->dbName='ad_db';
		if (defined('MYSQLDBUSER')) $this->dbUser=MYSQLDBUSER; else $this->dbUser='ad_dbuser';
		if (defined('MYSQLDBPASS')) $this->dbPass=MYSQLDBPASS; else $this->dbPass='dbpw#13999';

		$this->result=NULL;
		$this->pagesize=0;
	}


	// connect to database (private)
	function dbConnect() {
		if (is_null($this->db)) {
			if ($this->db=@mysql_connect($this->dbHost, $this->dbUser, $this->dbPass)) {
				if (!@mysql_select_db($this->dbName, $this->db)) $this->db=NULL;
			}
		}
		return $this->db;
	}


	// disconnect from database
	function dbDisconnect() {
		if (!is_null($this->db)) {
			@mysql_close($this->db);
			$this->db=NULL;
		}
		return $this->db;
	}


	// run a query. Returns true if information is returned.
	function fetch($sql=';') {

		$this->result=NULL;

		if (!is_null($this->dbConnect())) {

			$sql=trim($sql);
			$this->rowcount=-1;
			$this->pagecount=0;
			$this->rowfrom=0;
			$this->rowto=0;

			if ($this->result=@mysql_query($sql, $this->db)) {

				if (strpos(strtolower($sql), 'select')===false) {

					// get affected rows for INSERT, UPDATE or DELETE
					$this->rowcount=@mysql_affected_rows();
				}
				else {

					// get returned rows for SELECT
					$this->rowcount=@mysql_num_rows($this->result);
					$this->rowfrom=1;
					$this->rowto=$this->rowcount;

					// calculate paging information
					if ($this->pagesize>0) { $this->pagecount=intval(($this->rowcount-1) / $this->pagesize)+1; }
				}

			}
			else $this->result=NULL;

		}

		return !is_null($this->result);
	}


	// fetch a row as an associative array
	function rowassoc() {
		if (!is_null($this->result)) return @mysql_fetch_assoc($this->result);
	}


	// fetch a row as a numeric array
	function row() {
		if (!is_null($this->result)) return @mysql_fetch_row($this->result);
	}


	// go to a particular page
	function pagejump($page=1) {

		$jump=false;

		if ($page>=1 && $page<=$this->pagecount) {

			if (@mysql_data_seek($this->result, ($page-1)*$this->pagesize)) {

				// calculate row from
				$this->rowfrom=(($page-1)*$this->pagesize+1);

				// calculate row to
				$this->rowto=$page*$this->pagesize;
				if ($page==$this->pagecount) { $this->rowto-=($this->rowto - $this->rowcount); }

				$jump=true;
			}
		}

		return $jump;
	}

}
?>